package com.glgame.glgame;

import java.nio.FloatBuffer;

import javax.microedition.khronos.opengles.GL10;

public class AndroidRobot extends GlObject{
	GlColor color = new GlColor(); //一个封装着 rgba 四元素的简单类
	
	public AndroidRobot() {
		super();
		
		// 颜色为绿色
		color.set(0,1,0,0);
		
		//body
		// 2 arms
		// 2 leg
		// head: 2 eyes, 2 line, face
		Arm arms[] = new Arm[2];
		Leg legs[] = new Leg[2];
		Head head;
		Body body;
		
		// 构建身体部位
		arms[0] = new Arm();
		arms[1] = new Arm();
		legs[0] = new Leg();
		legs[1] = new Leg();
		head = new Head();
		body = new Body();
		
		// 调整身体部件位置
		body.setXY(0, 0); // 身体为中心
		head.setXY(0, -65);
		arms[0].setXY(-55,0);
		arms[1].setXY(55, 0);
		legs[0].setXY(-20, 60);
		legs[1].setXY(20, 60);
		
		// 安装身体部位
		addChild(body);
		addChild(head);
		addChild(arms[0]);
		addChild(arms[1]);
		addChild(legs[0]);
		addChild(legs[1]);
		
	}
	
	public void draw(GL10 gl)
	{
		// 设置颜色为
		gl.glColor4f(color.red, color.green, color.blue, color.alpha);
	}
	
	// 胳膊
	class Arm extends GlObject{
		public void draw(GL10 gl)
		{
			drawQuater(gl, -10, -68, 10, 50);
		}
	}
	
	// 腿
	class Leg extends GlObject{
			public void draw(GL10 gl)
			{
				drawQuater(gl, -15,0,15, 40);
			}
	}
	
	// 身体
	class Body extends GlObject{
		public void draw(GL10 gl)
		{
			drawQuater(gl, -40, -60, 40, 60);
		}
	}
	
	//头
	class Head extends GlObject{
		
		public Head()
		{
			Eye eyes[] = new Eye[2];
			eyes[0] = new Eye();
			eyes[1] = new Eye();
			
			eyes[0].setXY(-20, -10);
			eyes[1].setXY(20, -10);
			
			addChild(new Face());
			addChild(new Antenna());
			addChild(eyes[0]);
			addChild(eyes[1]);
		}
		
		// 眼睛
		class Eye extends GlObject{
			public void draw(GL10 gl){
				//眼睛扣洞
				gl.glColor4f(0, 0, 0, 0);
				drawQuater(gl, -4, -4, 4,4);
				//还原颜色
				gl.glColor4f(color.red, color.green, color.blue, color.alpha);
			}
		}
		
		// 脸
		class Face extends GlObject{
			public void draw(GL10 gl){
				drawArc(gl, 40, 0, 180);				
			}
		}
		
		// 天线
		class Antenna extends GlObject{
			public void draw(GL10 gl){
				drawLine(gl,0,0, -50,-50);
				drawLine(gl, 0, 0, 50, -50);
			}
		}
	}
}
